echo(version=version());
$fn = 100;


// CONSTANTES
JEU = 0.3;
INFINI = 1000;
D_TUBE_ALU = 8;
D_TROU_BLOCAGE = 3;
E_PAROIES_TUBE = 5;

// CONSTANTES CALCULÉES
D_INT_TUBE_GUIDE = ( D_TUBE_ALU + (2 * JEU) );
D_EXT_TUBE_GUIDE = D_INT_TUBE_GUIDE + (E_PAROIES_TUBE* 2);
H_TUBE_GUIDE = (D_TUBE_ALU) * 4;


// AFFICHAGE
vue_1();

// VUES
module vue_1() {
    piece_complete();
    }


// MODULES

// H = hauteur du tube
// D1 = grand diamètre ext
// D2 = petit diamètre int
module fonction_tube (H,D1,D2)   {
    difference() {
        cylinder(h = H , d = D1 , center = false);
        cylinder(h = INFINI , d = D2 , center = false);
        }
    }

module tube() {
        color("red")  fonction_tube(  H_TUBE_GUIDE , D_EXT_TUBE_GUIDE , D_INT_TUBE_GUIDE );
    }

module stop_tube() {
     color("black") translate([0,0,0]) cylinder(h = D_EXT_TUBE_GUIDE , d = D_EXT_TUBE_GUIDE , center = false);
    }
    
module arrondi() {
     color("yellow") sphere(D_EXT_TUBE_GUIDE / 2, $fn=100); 
    }    

module trou_blocage() {
    color("silver") translate([0,0,H_TUBE_GUIDE - 10]) rotate([0,90,0]) cylinder(h = D_EXT_TUBE_GUIDE , d = D_TROU_BLOCAGE , center = true);
}
    
module piece () {
    difference() {
        union () {
            tube();
            stop_tube();
            arrondi();
            }
         trou_blocage();   
        }
    }

module connecteur () {
    color("pink") rotate([0,0,0]) piece();
    color("blue") rotate([-90,0,0]) rotate([0,60,0])piece();
    color("grey") rotate([-90,0,0]) rotate([0,-60,0])piece();
    color("red") rotate([-90,0,0]) piece();
    }

module piece_complete() {
   connecteur ();
    }


